module const_uye_islevler_1;

import std.stdio;

struct Topluluk {
    int[] elemanlar;

    inout(int)[] başTarafı(size_t n) inout {
        return elemanlar[0 .. n];
    }
}

void main() {
    {
        // immutable bir Topluluk nesnesi
        auto topluluk = immutable(Topluluk)([ 1, 2, 3 ]);
        auto dilim = topluluk.başTarafı(2);
        writeln(typeof(dilim).stringof);
    }
    {
        // const bir Topluluk nesnesi
        auto topluluk = const(Topluluk)([ 1, 2, 3 ]);
        auto dilim = topluluk.başTarafı(2);
        writeln(typeof(dilim).stringof);
    }
    {
        // Değişebilen bir Topluluk nesnesi
        auto topluluk = Topluluk([ 1, 2, 3 ]);
        auto dilim = topluluk.başTarafı(2);
        writeln(typeof(dilim).stringof);
    }
}
