module es_zamanli_11;

import std.stdio;
import std.concurrency;
import std.conv;

struct HesapHatası {
    string neden;
}

struct Sonlan {
}

void hesapçı() {
    bool devam_mı = true;

    while (devam_mı) {
        receive(
            (string mesaj) {
                try {
                    ownerTid.send(to!double(mesaj) + 0.5);

                } catch (Exception hata) {
                    ownerTid.send(HesapHatası(hata.msg));
                }
            },

            (Sonlan mesaj) {
                devam_mı = false;
            });
    }
}

void main() {
    Tid hesapçı = spawn(&hesapçı);

    hesapçı.send("1.2");
    hesapçı.send("merhaba");  // ← hatalı veri
    hesapçı.send("3.4");
    hesapçı.send(Sonlan());

    foreach (i; 0 .. 3) {
        writef("sonuç %s: ", i);

        receive(
            (double mesaj) {
                writeln(mesaj);
            },

            (HesapHatası hata) {
                writefln("HATA! '%s'", hata.neden);
            });
    }
}
