module gostergeler_cozum_2;

struct Düğüm(T) {
    T eleman;
    Düğüm * sonraki;

    string toString() const {
        string sonuç = to!string(eleman);

        if (sonraki) {
            sonuç ~= " -> " ~ to!string(*sonraki);
        }

        return sonuç;
    }
}

struct Liste(T) {
    Düğüm!T * baş;

    void başınaEkle(T eleman) {
        baş = new Düğüm!T(eleman, baş);
    }

    string toString() const {
        return format("(%s)", baş ? to!string(*baş) : "");
    }
}
import std.stdio;
import std.conv;
import std.string;

// ...

struct Nokta {
    double x;
    double y;

    string toString() const {
        return format("(%s,%s)", x, y);
    }
}

void main() {
    Liste!Nokta noktalar;

    noktalar.başınaEkle(Nokta(1.1, 2.2));
    noktalar.başınaEkle(Nokta(3.3, 4.4));
    noktalar.başınaEkle(Nokta(5.5, 6.6));

    writeln(noktalar);
}
