module ic_tanimlar_5;

class Dış {
    int dışÜye;

    class İç {
        int işlev() {
            /* İç sınıf dış sınıfın üyelerine erişebilir. */
            return dışÜye * 2;
        }

        Dış dışNesne() {
            /* İç nesne kendi kapsamı olan dış nesnesine
             * 'outer' anahtar sözcüğüyle erişebilir. Bu
             * örnekte yalnızca dönüş değeri olarak
             * kullanıyor.  */
            return this.outer;
        }
    }

    İç algoritma() {
        /* Dış kendisini kapsam olarak kullanacak olan bir İç
         * nesnesini özel 'this.new' söz dizimi ile kurar. */
        return this.new İç();
    }
}

void main() {
    auto dış = new Dış();

    /* Dış'ın bir işlevinin bir İç nesnesi döndürmesi: */
    auto iç = dış.algoritma();

    /* Döndürülen nesnenin kullanılması: */
    iç.işlev();

    /* Doğal olarak 'iç'in kapsamı 'dış'tır: */
    assert(iç.dışNesne() is dış);
}
