module islevler_5;

import std.stdio;

enum satırAdedi = 20;
enum sütunAdedi = 60;

/* alias, "takma isim" anlamına gelir. Programın geri
 * kalanında hep dchar[sütunAdedi] yazmak yerine, daha
 * açıklayıcı olarak 'Satır' yazabilmemizi sağlıyor.
 *
 * Dikkat ederseniz Satır "sabit uzunluklu dizi" türüdür. */
alias Satır = dchar[sütunAdedi];

/* Bir Satır dilimine de kısaca 'Kağıt' takma ismini
 * veriyoruz. */
alias Kağıt = Satır[];

/* Verilen kağıdı satır satır ve kare kare çıkışa gönderir. */
void kağıdıGöster(Kağıt kağıt) {
    foreach (satır; kağıt) {
        writeln(satır);
    }
}

/* Verilen kağıdın belirtilen yerine bir benek koyar; bir
 * anlamda o kareyi "boyar". */
void benekKoy(Kağıt kağıt, int satır, int sütun) {
    kağıt[satır][sütun] = '#';
}

/* Kağıdın belirtilen yerinden aşağıya doğru, belirtilen
 * uzunlukta çizgi çizer. */
void düşeyÇizgiÇiz(Kağıt kağıt, int satır,
                   int sütun, int uzunluk) {
    foreach (çizilecekSatır; satır .. satır + uzunluk) {
        benekKoy(kağıt, çizilecekSatır, sütun);
    }
}

void main() {
    Satır boşSatır = '.';

    /* Hiç satırı bulunmayan bir kağıt */
    Kağıt kağıt;

    /* Ona boş satırlar ekliyoruz */
    foreach (i; 0 .. satırAdedi) {
        kağıt ~= boşSatır;
    }

    /* Ve kullanmaya başlıyoruz */
    benekKoy(kağıt, 7, 30);
    düşeyÇizgiÇiz(kağıt, 5, 10, 4);

    kağıdıGöster(kağıt);
}
