module kapamalar_3;

int[] süz_ve_dönüştür(const int[] sayılar) {
    int[] sonuç;

    foreach (sayı; sayılar) {
        if (sayı > 0) {                       // süzme,
            immutable yeniDeğer = sayı * 10;  // ve dönüştürme
            sonuç ~= yeniDeğer;
        }
    }

    return sonuç;
}
import std.stdio;
import std.random;

void main() {
    int[] sayılar;

    // Rasgele 20 sayı
    foreach (i; 0 .. 20) {
        sayılar ~= uniform(0, 10) - 5;
    }

    writeln("giriş: ", sayılar);
    writeln("sonuç: ", süz_ve_dönüştür(sayılar));
}
