module kosut_islemler_8;

import std.stdio;
import std.algorithm;
import core.thread;

struct Öğrenci {
    int numara;
    int[] notlar;

    double ortalamaNot() {
        writeln(numara,
                " numaralı öğrencinin işlemi başladı");
        Thread.sleep(1.seconds);

        const ortalama = notlar.sum / notlar.length;

        writeln(numara, " numaralı öğrencinin işlemi bitti");
        return ortalama;
    }
}

void main() {
    Öğrenci[] öğrenciler;

    foreach (i; 0 .. 10) {
        /* Her öğrenciye 80'li ve 90'lı iki not */
        öğrenciler ~= Öğrenci(i, [80 + i, 90 + i]);
    }

    auto sonuçlar = map!(ö => ö.ortalamaNot)(öğrenciler);

    foreach (sonuç; sonuçlar) {
        writeln(sonuç);
    }
}
