module ozel_islevler_4;

import std.stdio;

struct S {
    this(int i) {
        writeln("Bir nesne kuruluyor");
    }

    this(int i) const {
        writeln("const bir nesne kuruluyor");
    }

    this(int i) immutable {
        writeln("immutable bir nesne kuruluyor");
    }

    /* 'shared' anahtar sözcüğünü ilerideki bir bölümde
     * göreceğiz. */
    this(int i) shared {
        writeln("shared bir nesne kuruluyor");
    }
}

void main() {
    auto d = S(1);
    const c = S(2);
    immutable i = S(3);
    shared s = S(4);
}
