module sozlesmeli_3;

import std.exception;

inout(int)[] ortadakiler(inout(int)[] asılDilim, size_t uzunluk)
out (sonuç) {
    assert(sonuç.length == uzunluk);

} do {
    enforce(asılDilim.length >= uzunluk);

    immutable baş = (asılDilim.length - uzunluk) / 2;
    immutable son = baş + uzunluk;

    return asılDilim[baş .. son];
}

unittest {
    auto dilim = [1, 2, 3, 4, 5];

    assert(ortadakiler(dilim, 3) == [2, 3, 4]);
    assert(ortadakiler(dilim, 2) == [2, 3]);
    assert(ortadakiler(dilim, 5) == dilim);
}

void main() {
}
