module tureme_1;

import std.stdio;
import std.string;

class Saat {
    override string toString() const {
        return format("%02s:%02s:%02s", saat, dakika, saniye);
    }

    // ...
    int saat;
    int dakika;
    int saniye;

    void ayarla(int saat, int dakika, int saniye = 0) {
        this.saat = saat;
        this.dakika = dakika;
        this.saniye = saniye;
    }
    this(int saat, int dakika, int saniye) {
        this.saat = saat;
        this.dakika = dakika;
        this.saniye = saniye;
    }

    // ...
}

class ÇalarSaat : Saat {
    override string toString() const {
        return format("%s ♫%02s:%02s", super.toString(),
                      alarmSaati, alarmDakikası);
    }

    // ...
    int alarmSaati;
    int alarmDakikası;

    void alarmıKur(int saat, int dakika) {
        alarmSaati = saat;
        alarmDakikası = dakika;
    }
    this(int saat, int dakika, int saniye,    // Saat için
         int alarmSaati, int alarmDakikası) { // ÇalarSaat için
        super(saat, dakika, saniye);
        this.alarmSaati = alarmSaati;
        this.alarmDakikası = alarmDakikası;
    }

    // ...
}
void main() {
    auto masaSaatim = new ÇalarSaat(10, 15, 0, 6, 45);
    writeln(masaSaatim);
}
