module yapilar_1;

import std.stdio;
struct GününSaati {
    int saat;
    int dakika;
}
GününSaati zamanEkle(GününSaati başlangıç,
                     GününSaati eklenecek) {
    GününSaati sonuç;

    sonuç.dakika = başlangıç.dakika + eklenecek.dakika;
    sonuç.saat = başlangıç.saat + eklenecek.saat;
    sonuç.saat += sonuç.dakika / 60;

    sonuç.dakika %= 60;
    sonuç.saat %= 24;

    return sonuç;
}
void main() {
    GününSaati dersBaşı;
    dersBaşı.saat = 8;
    dersBaşı.dakika = 30;

    GününSaati dersSüresi;
    dersSüresi.saat = 1;
    dersSüresi.dakika = 15;

    immutable dersSonu = zamanEkle(dersBaşı, dersSüresi);

    writefln("Ders sonu: %s:%s",
             dersSonu.saat, dersSonu.dakika);
}
