module yapilar_3;

import std.stdio;
struct GününSaati {
    int saat;
    int dakika;
}
GününSaati zamanEkle(GününSaati başlangıç,
                     GününSaati eklenecek) {
    GününSaati sonuç;

    sonuç.dakika = başlangıç.dakika + eklenecek.dakika;
    sonuç.saat = başlangıç.saat + eklenecek.saat;
    sonuç.saat += sonuç.dakika / 60;

    sonuç.dakika %= 60;
    sonuç.saat %= 24;

    return sonuç;
}
void main() {
    immutable dersBaşı = GününSaati(8, 30);
    immutable dersSüresi = GününSaati(1, 15);

    immutable dersSonu = zamanEkle(dersBaşı, dersSüresi);

    writefln("Ders sonu: %s:%s",
             dersSonu.saat, dersSonu.dakika);
}
