module birim_testler_cozum_3;

import std.algorithm;

dstring harfBaşa(dstring dizgi, dchar harf) {
    dchar[] sonuç = dizgi.dup;
    partition!(e => e == harf, SwapStrategy.stable)(sonuç);

    return sonuç.idup;
}

unittest {
    immutable dizgi = "merhaba"d;

    assert(harfBaşa(dizgi, 'm') == "merhaba");
    assert(harfBaşa(dizgi, 'e') == "emrhaba");
    assert(harfBaşa(dizgi, 'a') == "aamerhb");
}

void main() {
}
