module birim_testler_cozum_4;

dstring tekrarlıDizi(int adet, dchar harf) {
    dstring dizi;

    foreach (i; 0..adet) {
        dizi ~= harf;
    }

    return dizi;
}

unittest {
    assert(tekrarlıDizi(3, 'z') == "zzz");
    assert(tekrarlıDizi(10, 'ğ') == "ğğğğğğğğğğ");
}

dstring harfBaşa(dstring dizgi, dchar harf) {
    int özelHarfAdedi;
    dstring sonTaraf;

    foreach (eleman; dizgi) {
        if (eleman == harf) {
            ++özelHarfAdedi;

        } else {
            sonTaraf ~= eleman;
        }
    }

    return tekrarlıDizi(özelHarfAdedi, harf) ~ sonTaraf;
}

unittest {
    immutable dizgi = "merhaba"d;

    assert(harfBaşa(dizgi, 'm') == "merhaba");
    assert(harfBaşa(dizgi, 'e') == "emrhaba");
    assert(harfBaşa(dizgi, 'a') == "aamerhb");
}

void main() {
}
