module hatalar_6;

import std.stdio;
import std.exception;

int dosyadanZarOku() {
    auto dosya = File("zarin_yazili_oldugu_dosya", "r");

    int zar;
    dosya.readf(" %s", &zar);

    return zar;
}

int dosyadanZarOkumayıDene() {
    int zar;

    try {
        zar = dosyadanZarOku();

    } catch (std.exception.ErrnoException hata) {
        writeln("(Dosyadan okuyamadım; 1 varsayıyorum)");
        zar = 1;
    }

    return zar;
}

void main() {
    const int zar = dosyadanZarOkumayıDene();

    writeln("Zar: ", zar);
}
