module interface_2;

import std.stdio;

struct Nokta {
    size_t numara;    // Nesnenin kendi numarası
    int satır;
    int sütun;

    // Bundan sonra oluşturulacak olan nesnenin numarası
    static size_t sonrakiNumara;

    this(int satır, int sütun) {
        this.satır = satır;
        this.sütun = sütun;
        this.numara = yeniNumaraBelirle();
    }

    static size_t yeniNumaraBelirle() {
        immutable yeniNumara = sonrakiNumara;
        ++sonrakiNumara;
        return yeniNumara;
    }
}

void main() {
    auto üstteki = Nokta(7, 0);
    auto ortadaki = Nokta(8, 0);
    auto alttaki =  Nokta(9, 0);

    writeln(üstteki.numara);
    writeln(ortadaki.numara);
    writeln(alttaki.numara);
}
