module islec_yukleme_2;

struct Süre {
    int dakika;

    ref Süre opUnary(string işleç)()
            if (işleç == "++") {
        ++dakika;
        return this;
    }

    ref Süre opUnary(string işleç)()
            if (işleç == "--") {
        --dakika;
        return this;
    }

    ref Süre opOpAssign(string işleç)(int miktar)
            if (işleç == "+") {
        dakika += miktar;
        return this;
    }

    ref Süre opOpAssign(string işleç)(int miktar)
            if (işleç == "-") {
        dakika -= miktar;
        return this;
    }
}

unittest {
    auto süre = Süre(10);

    ++süre;
    assert(süre.dakika == 11);

    --süre;
    assert(süre.dakika == 10);

    süre += 5;
    assert(süre.dakika == 15);

    süre -= 3;
    assert(süre.dakika == 12);
}

void main() {
}
