module islevler_diger_8;

import std.stdio;
import std.string;
import std.range;

string menüSatırları(string[] seçenekler) {
    string sonuç;

    foreach (i, seçenek; seçenekler) {
        sonuç ~= format(" %s. %s\n", i + 1, seçenek);
    }

    return sonuç;
}

string menü(string başlık, string[] seçenekler,
            size_t genişlik) {
    return format("%s\n%s\n%s",
                  başlık.center(genişlik),
                  '='.repeat(genişlik),    // yatay çizgi
                  menüSatırları(seçenekler));
}

void main() {
    enum tatlıMenüsü =
        menü("Tatlılar",
             [ "Baklava", "Kadayıf", "Muhallebi" ], 20);

    writeln(tatlıMenüsü);
}
