module kapamalar_5;

import std.exception;

int[] ikiliHesap(int function(int, int) işlem,
                 const int[] soldakiler,
                 const int[] sağdakiler) {
    enforce(soldakiler.length == sağdakiler.length);

    int[] sonuçlar;

    foreach (i; 0 .. soldakiler.length) {
        sonuçlar ~= işlem(soldakiler[i], sağdakiler[i]);
    }

    return sonuçlar;
}
import std.stdio;

void main() {
    writeln(ikiliHesap((a, b) => (a * 10) + b,
                       [ 1, 2, 3 ],
                       [ 4, 5, 6 ]));
}
