module katmalar_1;

mixin template KöşeDizisiOlanağı(T, size_t adet) {
    T[adet] köşeler;

    void köşeDeğiştir(size_t indeks, T köşe) {
        köşeler[indeks] = köşe;
    }

    void köşeleriGöster() {
        writeln("Bütün köşelerim:");

        foreach (i, köşe; köşeler) {
            writef("%s:%s ", i, köşe);
        }

        writeln();
    }
}
struct Çizgi {
     mixin KöşeDizisiOlanağı!(int, 2);
}
import std.stdio;

void main() {
    auto çizgi = Çizgi();
    çizgi.köşeDeğiştir(0, 100);
    çizgi.köşeDeğiştir(1, 200);
    çizgi.köşeleriGöster();
}
