module ozel_islevler_5;

import std.stdio;

struct Öğrenci {
    const char[] kayıtDosyası;
    size_t[] notlar;

    this(const char[] kayıtDosyası) {
        this.kayıtDosyası = kayıtDosyası;
    }

    void notlarıKaydet() {
        auto dosya = File(kayıtDosyası.idup, "w");
        dosya.writeln("Öğrencinin notları:");
        dosya.writeln(notlar);
    }

    // ...
}

void main() {
    char[] dosyaİsmi;
    dosyaİsmi ~= "ogrenci_notlari";

    auto öğrenci = Öğrenci(dosyaİsmi);

    // ...

    /* dosyaİsmi sonradan değiştiriliyor olsun (bu örnekte
     * bütün harfleri 'A' oluyor): */
    dosyaİsmi[] = 'A';

    // ...

    /* Notlar yanlış dosyaya kaydedilecektir: */
    öğrenci.notlarıKaydet();
}
