module ozel_islevler_7;

import std.stdio;
import std.datetime;

// Mesaj yazıcı
struct Logger {
    File dosya;

    this(File dosya) {
        this.dosya = dosya;
        log("Başlıyor");
    }

    ~this() {
        log("Sonlanıyor");    // Son mesaj olması istenmiş
    }

    void log(string mesaj) {
        dosya.writefln("%s %s", Clock.currTime(), mesaj);
    }
}

void main() {
    auto logger = Logger(stdout);

    logger.log("main başladı");
    logger.log("foo çağrılıyor");
    foo(logger);
    logger.log("main'e dönüldü");
}

void foo(Logger logger) {
    logger.log("foo başladı");
}
