module pragma_3;

import std.stdio;
import std.datetime.stopwatch;

// Oldukça hızlı bir işlev içeriği:
ubyte hesapla(ubyte i) {
    return cast(ubyte)(i * 42);
}

void main() {
    size_t sayaç = 0;

    StopWatch kronometre;
    kronometre.start();

    // Çok sayıda tekrarlanan küçük bir döngü:
    foreach (i; 0 .. 100_000_000) {
        const parametre = cast(ubyte)i;

        if (hesapla(parametre) == parametre) {
            ++sayaç;
        }
    }

    kronometre.stop();

    writefln("%s milisaniye", kronometre.peek.total!"msecs");
}
