module sablonlar_ayrintili_5;

import std.stdio;
import std.string;

class XmlElemanı(string isim) {
    double değer;

    this(double değer) {
        this.değer = değer;
    }

    override string toString() const {
        return format("<%s>%s</%s>", isim, değer, isim);
    }
}
alias Konum = XmlElemanı!"konum";
alias Sıcaklık = XmlElemanı!"sıcaklık";
alias Ağırlık = XmlElemanı!"ağırlık";

void main() {
    Object[] elemanlar;

    elemanlar ~= new Konum(1);
    elemanlar ~= new Sıcaklık(23);
    elemanlar ~= new Ağırlık(78);

    writeln(elemanlar);
}
