module yapilar_2;

import std.math;

struct Deneme {
    char   karakter;
    int    tamsayı;
    double kesirli;
}

void main() {
    // Bütün değerlerle
    auto d1 = Deneme('a', 1, 2.3);
    assert(d1.karakter == 'a');
    assert(d1.tamsayı == 1);
    assert(d1.kesirli == 2.3);

    // Sonuncusu eksik
    auto d2 = Deneme('a', 1);
    assert(d2.karakter == 'a');
    assert(d2.tamsayı == 1);
    assert(isNaN(d2.kesirli));

    // Son ikisi eksik
    auto d3 = Deneme('a');
    assert(d3.karakter == 'a');
    assert(d3.tamsayı == int.init);
    assert(isNaN(d3.kesirli));

    // Hiçbirisi yok
    auto d4 = Deneme();
    assert(d4.karakter == char.init);
    assert(d4.tamsayı == int.init);
    assert(isNaN(d4.kesirli));

    // Yukarıdakiyle aynı şey
    Deneme d5;
    assert(d5.karakter == char.init);
    assert(d5.tamsayı == int.init);
    assert(isNaN(d5.kesirli));
}
